# Copyright (C) 2004 Philippe Normand <phil@respyre.org>
#
# This file is part of XMLObject (http://xmlobject.base-art.net)
#
# Under PSF License (see COPYING)
# $HeadURL: https://svn.base-art.net/full/xmlobject/trunk/XMLObject/utils.py $
# $Id: utils.py 19 2004-08-15 15:47:30Z test $


from types import UnicodeType

def lowWord(word):
    " FoObar -> foObar "
    return word[0].lower() + word[1:]

def titleWord(word):
    " foObar -> FoObar "
    return word[0].upper() + word[1:]

def encode(v,enc = "iso-8859-1"):
    if isinstance(v, UnicodeType):
        v = v.encode(enc)
    return v

def replaceAll(initialString, translationHash):
    """ for each (toReplace, replacement) in `translationHash`
        applying the query-replace operation to `initialString`
    """
    result = ''
    if initialString is not None:
        result = initialString
        for key, value in translationHash:
            result = result.replace(key, value)
    return result

def contains(list1, list2):
    """ Check if some elements of list1 appear in list2

        Return the intersection of the two lists
    """
    return [ it1 for it1 in list1 if it1 in list2 ]

def getDirectChildrenWithName(parent, name):
    """ Fetch *direct* sub-nodes of a `parent` DOM tree. These
        nodes must have a name matching `name`.

        Return a list of DOM Nodes.
    """
    return [ node for node in parent.childNodes
             if node.nodeType == node.ELEMENT_NODE and \
             node.localName == name ]
