#!/usr/bin/env python
import sys

try:
    from distutils.core import setup
    from distutils.command.sdist import sdist
except ImportError:
    print "python-dev package is missing."
    sys.exit()

# patch distutils if it can't cope with the "classifiers" keyword
if sys.version < '2.2.3':
    from distutils.dist import DistributionMetadata
    DistributionMetadata.classifiers = None
    DistributionMetadata.download_url = None


class MySdist(sdist):
    def prune_file_list (self):
        " exclude .svn versioning infos "
        sdist.prune_file_list(self)
        self.filelist.exclude_pattern(r'/(\.svn)/.*', is_regex=1)
        

setup( name = "XMLObject",
       version = "0.1.2",
       description = "An XML wrapper to Python Objects",
       long_description = """\
XMLObject is an object-xml mapper. It allows to translate XML to Python
objects and vice-versa. Your developer life is made easier :

- design some classes with special attributes
- manipulate the objects in the Python way
- translate to XML
- import from XML to Python objects
       """,
       keywords = [ 'xml', 'mapping', 'dtd', 'schema' ],
       url = "http://xmlobject.base-art.net",
       download_url = "http://xmlobject.base-art.net/download/",
       classifiers = [ "Development Status :: 3 - Alpha",
                       "Intended Audience :: Developers",
                       "License :: OSI Approved :: Python Software Foundation License",
                       "Programming Language :: Python",
                       "Topic :: Text Processing :: Markup :: XML",
                       "Topic :: Software Development :: Libraries :: Python Modules",
                     ],
       license = "PSF",
       author = "Philippe Normand",
       author_email = "phil@respyre.org",
       maintainer = "Philippe Normand",
       maintainer_email = "phil@respyre.org",
       packages = [ 'XMLObject', 'XMLObject.Validation' ],
       cmdclass = {'sdist': MySdist}
     )
